#pragma once

#include "memory_utils.h"
#include "region.h"
#include "send_flexpage.h"



/* A flexpage abstraction. */

class Flexpage
{
protected:
    unsigned int _counter;
    flags_t _flags;

public:
    Region *region;

    /* General flexpage characteristics. */

    offset_t base_addr, size;
    offset_t base_offset;

    /* Transient debugging information. */

    offset_t page_addr, page_offset;

    /* Associate a flexpage with a memory 'region'. */

    explicit Flexpage(Region *region) : region(region)
    {
    }

    void reset(offset_t offset);

    bool decrement();

    void increment();

    void invalidate();

    bool valid();

    bool supports_position(offset_t position);

    void upgrade(flags_t flags);

    SendFlexpage to_send(offset_t offset, offset_t hot_spot, offset_t max_offset=0);

    SendFlexpage to_unmap();
};

// vim: tabstop=4 expandtab shiftwidth=4
